/**
 * Intrinio API
 * Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
 *
 * OpenAPI spec version: 2.8.8
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: unset
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.intrinioSDK) {
      root.intrinioSDK = {};
    }
    root.intrinioSDK.MovingAverageConvergenceDivergenceTechnicalValue = factory(root.intrinioSDK.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The MovingAverageConvergenceDivergenceTechnicalValue model module.
   * @module model/MovingAverageConvergenceDivergenceTechnicalValue
   * @version 5.1.0
   */

  /**
   * Constructs a new <code>MovingAverageConvergenceDivergenceTechnicalValue</code>.
   * The date_time, macd_histogram, macd_line, and signal_line values of a Moving Average Convergence Divergence technical indicator calculation
   * @alias module:model/MovingAverageConvergenceDivergenceTechnicalValue
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>MovingAverageConvergenceDivergenceTechnicalValue</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MovingAverageConvergenceDivergenceTechnicalValue} obj Optional instance to populate.
   * @return {module:model/MovingAverageConvergenceDivergenceTechnicalValue} The populated <code>MovingAverageConvergenceDivergenceTechnicalValue</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('date_time')) {
        obj['date_time'] = ApiClient.convertToType(data['date_time'], 'Date');
      }
      if (data.hasOwnProperty('macd_histogram')) {
        obj['macd_histogram'] = ApiClient.convertToType(data['macd_histogram'], 'Number');
      }
      if (data.hasOwnProperty('macd_line')) {
        obj['macd_line'] = ApiClient.convertToType(data['macd_line'], 'Number');
      }
      if (data.hasOwnProperty('signal_line')) {
        obj['signal_line'] = ApiClient.convertToType(data['signal_line'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The date_time of the observation
   * @member {Date} date_time
   */
  exports.prototype['date_time'] = undefined;
  /**
   * The histogram value of the Moving Average Convergence Divergence calculation
   * @member {Number} macd_histogram
   */
  exports.prototype['macd_histogram'] = undefined;
  /**
   * The line value of the Moving Average Convergence Divergence calculation
   * @member {Number} macd_line
   */
  exports.prototype['macd_line'] = undefined;
  /**
   * The signal line value of the Moving Average Convergence Divergence calculation
   * @member {Number} signal_line
   */
  exports.prototype['signal_line'] = undefined;



  return exports;
}));


